
	#include	"AI8051U.h"

sbit    SCL = P1^5;		//IICʱŶ
sbit    SDA = P1^4;		//IICŶ

void  InitMPU6050(void);	//ʼMPU6050
void  Delay2us(void);
void  I2C_Start(void);
void  I2C_Stop(void);

bit   I2C_RecvACK(void);

void  I2C_SendByte(u8 dat);
u8	  I2C_RecvByte(void);
void I2C_WriteByte(u8 dat);
u8 I2C_ReadByte(void);
	
void  I2C_ReadPage(void);
void  I2C_WritePage(void);

u8	  Single_ReadI2C(u8 REG_Address);				//ȡI2C
void  Single_WriteI2C(u8 REG_Address,u8 REG_data);	//I2Cд


//I^CʱʱãμоƬֲ  6050ƼС1.3us ǻ⣬ʱʵ1.9us
//void Delay2us(void)
//{
//	u8 i;
//	i = 15;		// @24MHZ, 6 + 33 = 39T, 1.625us
//	while (--i);
//}



void Delay2us(void)	//@33.1776MHz
{
	unsigned long edata i;

	_nop_();
	i = 20UL;
	while (i) i--;
}
//**************************************
//I2Cʼź
//**************************************
void I2C_Start(void)
{
	Delay2us();                 //ʱ
	Delay2us();                 //ʱ
	SDA = 1;                    //
	SCL = 1;                    //ʱ
	Delay2us();                 //ʱ
	Delay2us();                 //ʱ
	SDA = 0;                    //½
	Delay2us();                 //ʱ
	SCL = 0;                    //ʱ
	Delay2us();                 //ʱ
}

//**************************************
//I2Cֹͣź
//**************************************
void I2C_Stop(void)
{
	Delay2us();                 //ʱ
	SDA = 0;                    //
	SCL = 1;                    //ʱ
	Delay2us();                 //ʱ
	SDA = 1;                    //
	Delay2us();                 //ʱ
}

//**************************************
//I2CACKӦ
//**************************************
void I2C_ACK(void)
{
	Delay2us();                 //ʱ
	SCL = 0;                    //
	SDA = 0;                    //
	Delay2us();                 //ʱ
	SCL = 1;                    //ʱ
	Delay2us();                 //ʱ
	SCL = 0;                    //
	SDA = 1;                    //
	Delay2us();                 //ʱ
}
//**************************************
//I2CNACKӦ
//**************************************
void I2C_NACK(void)
{
	Delay2us();                 //ʱ
	SCL = 0;                    //
	SDA = 1;                    //
	Delay2us();                 //ʱ
	SCL = 1;                    //ʱ
	Delay2us();                 //ʱ
	SCL = 0;                    //
	Delay2us();                 //ʱ
}
//**************************************
//I2CȴӦźŵ
//**************************************
unsigned char  I2C_WaitACK(void)
{
	unsigned int time_temp = 0;
    SCL = 1;                    //ʱ
	Delay2us();                 //ʱ
	 while(SDA)                                //ȴSDAΪ͵ƽ
    {
        time_temp++;
				Delay2us();                 //ʱ
        if(time_temp > 10)        //ʱǿƽI2Cͨ
        {
            I2C_Stop();
            return 1;
        }
    }
    SCL = 0;                    //ʱ
    Delay2us();                 //ʱ
    return 0;
}


//**************************************
//I2CӦź
//**************************************
bit I2C_RecvACK(void)
{
	SDA = 1;
	Delay2us();                 //ʱ
	SCL = 1;                    //ʱ
	Delay2us();                 //ʱ
	CY = SDA;                   //Ӧź
	SCL = 0;                    //ʱ
	Delay2us();                 //ʱ
	return CY;
}



//**************************************
//I2C߷һֽ
//**************************************
void I2C_WriteByte(u8 dat)
{
    u8 i;
        SCL = 0;                //ʱ
    for (i=0; i<8; i++)         //8λ
    {
			if((dat & 0x80) > 0)
					SDA = 1;                    //
        else
					SDA = 0;                    //
        dat <<= 1;              //Ƴݵλ
        Delay2us();             //ʱ
//        SDA = CY;               //ݿ
        SCL = 1;                //ʱ
        Delay2us();             //ʱ
        SCL = 0;                //ʱ
        Delay2us();             //ʱ
    }
    I2C_RecvACK();
}
//**************************************
//I2C߽һֽ
//**************************************
u8 I2C_ReadByte(void)
{
    u8 i;
    u8 dat = 0;
//    SDA = 1;                    //ʹڲ,׼ȡ,
    for (i=0; i<8; i++)         //8λ
    {
        SCL = 0;                //ʱ
        Delay2us();             //ʱ
        SCL = 1;                //ʱ
        dat <<= 1;
        SCL = 1;                //ʱ
        Delay2us();             //ʱ
        dat |= SDA;             //
        Delay2us();             //ʱ
    }
    return dat;
}

//**************************************
//I2C߷һֽ
//**************************************
void I2C_SendByte(u8 dat)
{
    u8 i;
    for (i=0; i<8; i++)         //8λ
    {
        dat <<= 1;              //Ƴݵλ
        SDA = CY;               //ݿ
        SCL = 1;                //ʱ
        Delay2us();             //ʱ
        SCL = 0;                //ʱ
        Delay2us();             //ʱ
    }
    I2C_RecvACK();
}

//**************************************
//I2C߽һֽ
//**************************************
u8 I2C_RecvByte(void)
{
    u8 i;
    u8 dat = 0;
    SDA = 1;                    //ʹڲ,׼ȡ,
    for (i=0; i<8; i++)         //8λ
    {
        dat <<= 1;
        SCL = 1;                //ʱ
        Delay2us();             //ʱ
        dat |= SDA;             //
        SCL = 0;                //ʱ
        Delay2us();             //ʱ
    }
    return dat;
}

//u8 I2C_RecvByte(void)
//{
//    u8 i;
//    u8 dat = 0;
//    SDA = 1;                    //ʹڲ,׼ȡ,
//    for (i=0; i<8; i++)         //8λ
//    {
//        dat <<= 1;
//        SCL = 1;                //ʱ
//        Delay2us();             //ʱ
//        dat |= SDA;             //
//        SCL = 0;                //ʱ
//        Delay2us();             //ʱ
//    }
//    return dat;
//}

//**************************************
//I2C豸дһֽ
//**************************************
void Single_WriteI2C(u8 REG_Address,u8 REG_data)
{
    I2C_Start();                  //ʼź
    I2C_WriteByte(MPU6500_SENSOR_ADDR << 1 | 0);   //豸ַ+дź
	I2C_WaitACK();
    I2C_WriteByte(REG_Address);    //ڲĴַ
	I2C_WaitACK();
    I2C_WriteByte(REG_data);       //ڲĴݣ
	I2C_WaitACK();
    I2C_Stop();                   //ֹͣź
}
//**************************************
//I2C豸ȡһֽ
//**************************************
/*
u8 Single_ReadI2C(u8 REG_Address)
{
	u8 REG_data;
	I2C_Start();                   //ʼź
	I2C_SendByte(SlaveAddress);    //豸ַ+дź
	I2C_SendByte(REG_Address);     //ʹ洢Ԫַ0ʼ
	I2C_Start();                   //ʼź
	I2C_SendByte(SlaveAddress+1);  //豸ַ+ź
	REG_data=I2C_RecvByte();       //Ĵ
	
	SDA = 1;                    //дӦź
	SCL = 1;                    //ʱ
	Delay2us();                 //ʱ
	SCL = 0;                    //ʱ
	Delay2us();                 //ʱ
	
	I2C_Stop();                    //ֹͣź
	return REG_data;
}
*/

//**************************************
//ʼMPU6050
//**************************************
void InitMPU6050(void)
{
//	P2n_open_drain(0x30);	//P2.4 -- SDA,   P2.5 -- SCL
//	Delay2us();
//	Delay2us();
//	Delay2us();
//	Delay2us();

	Single_WriteI2C(PWR_MGMT_1, 0x00);	//״̬
	Delay2us();
	Delay2us();
	Single_WriteI2C(SMPLRT_DIV, 0x07);  //125hz
	Delay2us();
	Delay2us();
	Single_WriteI2C(CONFIG, 0x04);      //21HZ˲ ʱA8.5ms G8.3ms  ˴ȡֵӦ൱ע⣬ʱϵͳΪ
	Delay2us();
	Delay2us();
	Single_WriteI2C(GYRO_CONFIG, 0x08); //500/S 65.5LSB/g
	Delay2us();
	Delay2us();
	Single_WriteI2C(ACCEL_CONFIG, 0x08);//ٶ+-4g  8192LSB/g
	Delay2us();
	Delay2us();
}

//**************************************
//ϳ
//**************************************
/*
int GetData(u8 REG_Address)
{
	char H,L;
	H = Single_ReadI2C(REG_Address);
	L = Single_ReadI2C(REG_Address+1);
//	return (H<<8)+L;   //ϳ
	return (((u16)H << 8) + L);   //ϳ
}
*/

void Read_MPU6050(u8 *buf)
{
	u8	i;
	
	I2C_Start();                  //ʼź
	I2C_WriteByte(MPU6500_SENSOR_ADDR<< 1 | 0);   //豸ַ+дź
	I2C_WaitACK();
	I2C_WriteByte(ACCEL_XOUT_H);    //ڲĴַ
	I2C_WaitACK();
	I2C_Start();                   //ʼź
	I2C_WriteByte(MPU6500_SENSOR_ADDR<< 1 | 1);  //豸ַ+ź
	I2C_WaitACK();
	for(i=0; i<13; i++)
	{
		buf[i] = I2C_ReadByte();       //Ĵ
		I2C_ACK();
//		SDA = 0;                    //дӦź
//		SCL = 1;                    //ʱ
//		Delay2us();                 //ʱ
//		SCL = 0;                    //ʱ
//		Delay2us();                 //ʱ
	}
		buf[i] = I2C_ReadByte();	//һֽ
I2C_ACK();
	I2C_Stop();                    //ֹͣź
}
